*	bmpld.s	for coerce

RUNS_HUMAN_VERSION	equ	3
	.include	doscall.mac

	.text
	.even

	.globl	_loadBMPfile

_loadBMPfile:
	movem.l	d3/a6,-(sp)
	move.l	12(sp),a6
	moveq.l	#0,d1
	move.l	d1,850(a6)	*clrUsed= 0
	move.l	d1,12(a6)	*currentbyte= 0
	move.l	d1,62(a6)	*bitcount= 0
	pea	2048.w		*filebufsize for header
	DOS	__MALLOC
	move.l	d0,4(a6)	*filebuf
	move.l	d0,-(sp)
	move.w	2(a6),-(sp)	*fn
	DOS	__READ
	lea	10(sp),sp
	bsr	_GetHeaderData
	move.l	d0,d3
	cmp.l	#200,d0		* ?PICSLICE_NORMAL
	beq	headerreadok
	move.l	a6,-(sp)
	bsr	_EndOfDraw
	addq.w	#4,sp
	move.l	d3,d0
	bra	loadbmpend

headerreadok:
	tst.l	850(a6)		*clrUsed
	beq	paletnouse
	moveq.l	#14,d1
	add.l	842(a6),d1	*hsize
	move.l	d1,-(sp)
	bsr	_ColorTableGet
	addq.w	#4,sp

paletnouse:
	tst.l	838(a6)		*compress
	beq	headercheckok
	move.l	a6,-(sp)
	bsr	_EndOfDraw
	addq.w	#4,sp
	moveq.l	#101,d0		*PICSLICE_EFORMAT
	add.w	d0,d0
	bra	loadbmpend

headercheckok:
	move.l	20(a6),d0
	add.w	d0,d0
	move.l	d0,854(a6)	*linebytes
bitcheck:
	move.l	20(a6),d0	*psi.width
	move.l	54(a6),d1	*psi.freelist(_bitcount)
	subq.l	#1,d1
	beq	bit1set
	subq.l	#3,d1
	beq	bit4set
	subq.l	#4,d1
	beq	bit8set

bit24set:			*24bit color
	move.l	d0,d1
	add.l	d1,d1
	add.l	d1,d0		*psi.width * 3
	addq.l	#3,d0
	move.l	#?bit16col,54(a6)
	bra	bufsizeget

bit1set:			*1bit color
	addq.l	#7,d0
	asr.l	#3,d0
	addq.l	#3,d0
	move.l	#?bit1col,54(a6)
	bra	bufsizeget

bit4set:			*4bit color
	addq.l	#1,d0
	asr.l	#1,d0
	addq.l	#3,d0
	move.l	#?bit4col,54(a6)
	bra	bufsizeget

bit8set:			*8bit color
	addq.l #3,d0
	move.l	#?bit8col,54(a6)

bufsizeget:
	moveq.l	#-4,d1		*~3
	and.l	d1,d0
	move.l	d0,42(a6)	*chainbufsize
	move.l	4(a6),-(sp)
	DOS	__MFREE
	addq.w	#4,sp
	move.l	42(a6),d0	*chainbufsize
	lsl.l	#3,d0
	move.l	d0,8(a6)	*filebufsize
	move.l	d0,-(sp)
	DOS	__MALLOC
	addq.w	#4,sp
	bmi	outofmem
	move.l	d0,4(a6)	*filebuf
	bra	filebufok

outofmem:
	move.l	a6,-(sp)
	bsr	_EndOfDraw
	addq.w	#4,sp
	move.l	#205,d0
	add.w	d0,d0
	bra	loadbmpend

filebufok:
	clr.w	-(sp)
	move.l	846(a6),-(sp)	*ioffset
	move.w	2(a6),-(sp)	*fn
	DOS	__SEEK
	addq.w	#8,sp

	move.l	850(a6),16(a6)	*realwidth( MaxColorGuaranteed )

	moveq.l	#100,d0
	add.w	d0,d0		*PICSLICE_NORMAL
loadbmpend:
	movem.l	(sp)+,d3/a6
	rts

	.even

_GetHeaderData:
	move.l	a3,-(sp)
	move.l	4(a6),a2	*filebuf
	move.l	12(a6),d0	*currentbyte
	lea.l	(a2,d0.l),a2
	move.b	(a2)+,d0	*id
	lsl.w	#8,d0		*id * 256
	move.b	(a2)+,d0
	addq.l	#2,12(a6)	*currentbyte += 2
	cmp.w	#$424d,d0
	bne	eformat
	lea	_Get4Bytes(OPC),a3
	jbsr	(a3)		*checkfilesize
	jbsr	(a3)		*getrsv
	tst.l	d0
	bne	eformat
	jbsr	(a3)
	move.l	d0,846(a6)	*ioffset
	jbsr	(a3)
	move.l	d0,842(a6)	*hsize
	moveq.l	#40,d1		*Windows 3.0 format
	cmp.l	d0,d1
	beq	win3form
	moveq.l	#12,d1		*OS/2 1.x format
	cmp.l	d0,d1
	beq	os2form
	moveq.l	#64,d1		*OS/2 2.0 format
	cmp.l	d0,d1
	bne	eformat
os2form:
	lea	_Get2Bytes(OPC),a3
win3form:
	jbsr	(a3)
	move.l	d0,20(a6)	*width
	jbsr	(a3)
	move.l	d0,24(a6)	*height
	bsr	_Get2Bytes
	moveq.l	#1,d1
	cmp.l	d0,d1		*?planes == 1
	beq	formatok
eformat:
	moveq.l	#101,d0		*PICSLICE_EFORMAT
	bra	formEend
formatok:
	bsr	_Get2Bytes
	move.l	d0,54(a6)	*bitcount
	move.l	842(a6),d0	*hsize
	moveq.l	#12,d1		*OS/2 2.x
	cmp.l	d0,d1
	beq	os2_1
	bsr	_Get4Bytes
	move.l	d0,838(a6)	*compress
	moveq.l	#-14,d0
	add.l	846(a6),d0	*ioffset
	sub.l	842(a6),d0	*hsize
	bpl	plus
	addq.l	#3,d0
plus:
	asr.l	#2,d0
	move.l	d0,850(a6)	*clrUsed
	bra	formNORend
os2_1:				*OS/2 1.x
	moveq.l	#0,d0
	move.l	d0,838(a6)	*compress
	move.l	54(a6),d1
	cmp.b	#24,d1
	beq	setos2_1clrUsed
	moveq.l	#1,d0
	lsl.l	d1,d0
setos2_1clrUsed:
	move.l	d0,850(a6)	*clrUsed
formNORend:
	moveq.l	#100,d0
formEend:
	add.w	d0,d0
	move.l	(sp)+,a3
	rts

	.even

_ColorTableGet:
	move.l	4(sp),d1	*currentbyte
	movem.l	d3/a3/a4/a5,-(sp)
	lea.l	_Red,a3
	lea.l	_Green,a4
	lea.l	_Blue,a5
	lea.l	12(a6),a1	*currentbyte
	move.l	d1,(a1)
	move.l	4(a6),a0	*filebuf
	lea.l	(a0,d1.l),a0
	move.l	850(a6),d3	*clrUsed
	moveq.l	#$fffffff8,d2
	move.l	842(a6),d0	*hsize
	lea.l	66(a6),a2	*colortable
	moveq.l	#12,d1		*OS/2 1.x
	cmp.l	d0,d1
	bne	mkcolent
	swap.w	d2
	clr.w	d2
	swap.w	d2
	bra	mkcolent

mkcollp:
	move.b	(a0)+,d1	*B
	move.b	d1,(a5)+
	lsr.b	#3,d1
	moveq.l	#0,d0
	move.b	(a0)+,d0	*G
	move.b	d0,(a4)+
	lsl.w	#5,d0
	move.b	(a0)+,d0	*R
	move.b	d0,(a3)+
	and.w	d2,d0
	add.w	d0,d0
	add.w	d0,d0
	or.b	d1,d0
	add.w	d0,d0
	move.w	d0,(a2)+
	tst.l	d2
	bmi	notOS2_1
	addq.l	#3,(a1)		*currentbyte += 3
	bra	mkcolent
notOS2_1:
	addq.l	#1,a0
	addq.l	#4,(a1)		*currentbyte += 4
mkcolent:
	dbra	d3,mkcollp

	movem.l	(sp)+,d3/a3/a4/a5
	rts

	.even

	.globl _drawBMP
_drawBMP:
	movem.l	d3/d4/d5/d6/d7/a3/a4/a5/a6,-(sp)
	move.l	40(sp),a6	*psi
	move.l	24(a6),d0	*y
	subq.l	#1,d0
	move.l	854(a6),d3
	mulu	d3,d0		*lenline * (y - 1)
	add.l	38(a6),d0
	move.l	d0,a4		*psi.bottom(_adrs)
	move.l	54(a6),a2
	move.w	22(a6),a3	*22(psi)->a3	width
	subq.w	#1,a3
	moveq.l	#$fffffff8,d2
nextbuf:
	move.l	8(a6),-(sp)
	move.l	4(a6),-(sp)
	move.w	2(a6),-(sp)
	DOS	__READ
	lea	10(sp),sp
	movea.l	4(a6),a1	*filebuf
	moveq.l	#0,d6		*bytecount
	moveq.l	#0,d7
	moveq.l	#8,d5
	lea.l	66(a6),a0	*colortable
	bra	?96
?108:
	cmp.l	38(a6),a4
	bge	?99
	move.l	a6,-(sp)
	bsr	_EndOfDraw
	addq.w	#4,sp
	move.l	#201,d0
	bra	?97
?99:
	move.w	a3,d4
	movea.l	a4,a5
psetlp:
	jsr	(a2)
nextdot:
	bra	lwnormalizeent

lwnormalizelp:
	addq.l	#1,d6
lwnormalizeent:
	moveq.l	#3,d0
	and.b	d6,d0
	bne	lwnormalizelp

	movea.l	4(a6),a1	*filebuf
	adda.l	d6,a1		*currentbyte
	moveq.l	#0,d7
	suba.l	d3,a4
?96:
	dbra	d5,?108
	bra	nextbuf
?97:
	movem.l	(sp)+,d3/d4/d5/d6/d7/a3/a4/a5/a6
	rts

	.even

?bit1col:
	subq.b	#1,d7
	bgt	readnextbit1
	moveq.l	#0,d0
	move.b	(a1)+,d0	*currentbyte
	move.w	d0,d2		*_leftData
	addq.l	#1,d6		*bytecount
	moveq.l	#8,d7
readnextbit1:
	moveq.l	#0,d0
	move.w	d2,d1		*_leftData
	bge	?bit1off
	moveq.l	#2,d0
?bit1off:
	add.w	d1,d1
	move.w	d1,d2		*_leftData
	move.w	(a0,d0.w),(a5)+
	dbra	d4,?bit1col
	rts

?bit4col:
	subq.w	#1,d7
	bgt	readnextbit4
	moveq.l	#0,d0
	move.b	(a1)+,d0	*currentbyte
	move.w	d0,d2
	addq.l	#1,d6		*bytecount
	moveq.l	#2,d7

readnextbit4:
	move.w	d2,d1
	move.w	d1,d0
	lsl.b	#4,d1
	move.w	d1,d2
	lsr.b	#4,d0
	and.w	#15,d0
	add.w	d0,d0
	move.w	(a0,d0.w),(a5)+
	dbra	d4,?bit4col
	rts

?bit8col:
	addq.l	#1,d6		*bytecount
	moveq.l	#0,d0
	move.b	(a1)+,d0
	add.w	d0,d0
	move.w	(a0,d0.w),(a5)+
	dbra	d4,?bit8col
	rts

?bit16col:
	addq.l	#3,d6		*bytecount
	move.b	(a1)+,d1	*currentbyte
	lsr.b	#3,d1	*B
	move.b	(a1)+,d0	*G
	lsl.w	#5,d0
	move.b	(a1)+,d0	*R
	and.b	d2,d0
	add.w	d0,d0
	add.w	d0,d0
	add.b	d1,d0
	add.w	d0,d0
	move.w	d0,(a5)+
	dbra	d4,?bit16col
	rts

	.even

_Get2Bytes:
	lea	4(a6),a1
	lea	12(a6),a0
	addq.l	#2,(a0)
	move.l	(a1),a2
	adda.l	(a0),a2
	moveq.l	#0,d0
	move.b	-(a2),d0
	lsl.w	#8,d0
	add.b	-(a2),d0
	rts

	.even

_Get4Bytes:
	lea	4(a6),a1
	lea	12(a6),a0
	addq.l	#4,(a0)
	move.l	(a1),a2
	moveq.l	#0,d0
	adda.l	(a0),a2
	move.b	-(a2),d0
	lsl.w	#8,d0
	add.b	-(a2),d0
	swap.w	d0
	move.b	-(a2),d0
	lsl.w	#8,d0
	add.b	-(a2),d0
	rts

	.even
	.globl	_EndOfDraw
_EndOfDraw:
	move.l	4(sp),a1	*psi
	moveq.l	#0,d1
	move.l	(a1),d0
	beq	nofilehandle
	move.w	d0,-(sp)
	DOS	__CLOSE
	move.l	d1,(a1)
	addq.w	#2,sp
nofilehandle:
	move.l	4(a1),d0
	beq	nofilebuf
	move.l	d0,-(sp)
	DOS	__MFREE
	move.l	d1,4(a1)
	addq.w	#4,sp
nofilebuf:
	rts

	.even
	.end
