RUNS_HUMAN_VERSION	equ	3
	.include doscall.mac

	.text

_readBit1	macro
	local	?412,?410,?415,?endb2

	dbra	d7,?410		*readbit
	dbra	d6,?412
	bsr	_readData
	bra	?410
?412
	addq.l	#2,(a0)
	moveq.l	#15,d7
?410
	moveq.l	#0,d0
	movea.l	(a0),a1
	lsl.w	(a1)
	scc	d0
	addq.b	#1,d0

	endm

_readBit2	macro
	local	mokkai,?512,?510

	movea.l	(a0),a1
	moveq.l	#0,d1
mokkai
	dbra	d7,?510
	dbra	d6,?512
	bsr	_readData
	movea.l	(a0),a1
	bra	?510
?512
	addq.w	#2,a1
	moveq.l	#15,d7
?510
	move.w	(a1),d1
	add.l	d1,d1
	move.w	d1,(a1)
	dbra	d2,mokkai
	move.l	a1,(a0)
	moveq.l	#0,d0
	swap.w	d1
	move.w	d1,d0

	endm

_readBit	macro
	local	?21,?18,?10

	movea.l	(a0),a1
	moveq.l	#0,d1
	bra	?10
?21
	moveq.l	#0,d2
	move.w	d7,d0
	sub.w	d0,d3
	move.w	(a1),d2
	lsl.l	d0,d2
	move.w	d2,(a1)
	swap.w	d2
	lsl.l	d0,d1
	or.w	d2,d1
	dbra	d6,?18
	bsr	_readData
	movea.l	(a0),a1
	moveq.l	#16,d7
	bra	?10
?18
	addq.w	#2,a1
	moveq.l	#16,d7
?10
	cmp.w	d7,d3
	bgt	?21
	sub.w	d3,d7
	moveq.l	#0,d2
	move.w	(a1),d2
	lsl.l	d3,d2
	move.w	d2,(a1)
	swap.w	d2
	move.l	a1,(a0)
	lsl.l	d3,d1
	or.w	d2,d1
	move.l	d1,d0

	endm

_readBit7	macro
	local	?621,?618,?610

	movea.l	(a0),a1
	moveq.l	#0,d1
	cmp.w	d7,d3
	ble	?610
?621
	sub.w	d7,d3
	move.w	(a1),d1
	lsl.l	d7,d1
	move.w	d1,(a1)
	dbra	d6,?618
	bsr	_readData
	movea.l	(a0),a1
	moveq.l	#16,d7
	bra	?610
?618
	addq.w	#2,a1
	moveq.l	#16,d7
?610
	sub.w	d3,d7
	move.w	(a1),d1
	lsl.l	d3,d1
	move.w	d1,(a1)
	swap.w	d1
	move.l	a1,(a0)
	moveq.l	#0,d0
	move.w	d1,d0

	endm

squarecomment:
	.dc.b	"/XSS/"
	.even

	.globl	_loadPICfile
_loadPICfile:
	movem.l	d3/d4/d5/d6/d7/a3/a4/a5,-(sp)
	move.l	36(sp),a0	*psi
	movea.l	a0,a5		*psi
	move.l	#16384,d0
	move.l	d0,8(a0)	*filebufsize
	move.l	d0,-(sp)
	DOS	__MALLOC
	addq.w	#4,sp
	tst.l	d0
	bgt	memoryok
	move.l	#205,d0		*PICSLICE_NOMEMORY
	bra	?252
memoryok:
	move.l	d0,4(a0)	*filebuf
	lea.l	12(a0),a0	*currentbyte
	move.l	d0,(a0)		*currentbyte
	moveq.l	#0,d2
	move.l	d2,d6		*bytecount
	move.l	d2,d7		*bitcount
	move.w	d2,42(a0)	*freelist(_readerror)

	bsr	readchr		*init

	bsr	readchr
	cmp.b	#'P',d0
	bne	?275
	bsr	readchr
	cmp.b	#'I',d0
	bne	?275
	bsr	readchr
	cmp.b	#'C',d0
	bne	?275
	lea.l	squarecomment(OPC),a2
nomatch:
	moveq.l	#0,d2
comment_lp:
	bsr	readchr
	cmp.b	#$1a,d0
	beq	?258
	cmp.b	#5,d2
	bge	comment_lp
	cmp.b	(a2,d2.l),d0
	bne	nomatch
	addq.b	#1,d2
	bra	comment_lp
?258:
	tst.l	_NoExpand
	bpl	nocheck_adjust
	moveq.l	#0,d0
	cmp.b	#5,d2
	sne	d0
	addq.b	#1,d0
	move.l	d0,_NoExpand
nocheck_adjust:
	bsr	readchr
	tst.b	d0
	bne	?258
	bsr	readchr
	tst.b	d0
	bne	?275
	bsr	readchr
	tst.b	d0
	bne	?275
	bsr	readchr
	tst.b	d0
	bne	?275
	bsr	readchr
	moveq.l	#15,d2
	cmp.b	d0,d2
	beq	?263
?275:
	moveq.l	#101,d0
	add.w	d0,d0		*PICSLICE_EFORMAT
	bra	?252
?263:
	bsr	readchr
	lea	20(a5),a4	*width
	asl.l	#8,d0
	move.l	d0,(a4)
	bsr	readchr
	add.l	d0,(a4)+
	bsr	readchr
	asl.l	#8,d0
	move.l	d0,(a4)		*height
	bsr	readchr
	add.l	d0,(a4)

	move.l	-(a4),d1	*width
	add.w	d1,d1
	move.l	d1,-(a4)	*realwidth
	moveq.l	#0,d2
	move.l	d2,28(a5)
	move.w	d2,36(a5)
	move.l	d2,46(a5)	*y		34(a0)
	move.l	a5,a1

	moveq.l	#0,d1
	moveq.l	#127,d2
?269:
	lea.l	(a1,d1.w),a2
	clr.w	66(a2)
	subq.w	#2,d1
	move.b	d1,323(a2)	*prev
	addq.w	#4,d1
	move.b	d1,322(a2)	*next
	dbra	d2,?269

	clr.w	1346(a1)
	moveq.l	#1,d3
	bra	?271
?273:
	addq.l	#1,d3
?271:
	_readBit1
	bne	?273
	move.l	d3,-(sp)
	_readBit
	move.l	(sp)+,d3
	move.l	d0,a2
	moveq.l	#1,d0
	asl.l	d3,d0
	lea	-2(a2,d0.l),a2
	move.l	a2,32(a5)
	tst.w	54(a5)
	beq	?274
eread:
	move.l	#203,d0		*PICSLICE_EREAD
	bra	?252
?274:
	move.w	d6,48(a0)	*bytecount
	move.w	d7,52(a0)	*bitcount
	moveq.l	#100,d0
	add.w	d0,d0		*PICSLICE_NORMAL
	bra	readok
?252:
	move.l	d0,d7
	move.l	a5,-(sp)
	jbsr	_EndOfDraw
	addq.w	#4,sp
	move.l	d7,d0
readok:
	movem.l	(sp)+,d3/d4/d5/d6/d7/a3/a4/a5
	rts

	.even
readchr:
	moveq.l	#0,d0
	movea.l	(a0),a1
	move.w	(a1),d0
	subq.w	#8,d7
	ble	lowbyte
	move.w	d0,d1
	lsl.w	#8,d1
	move.w	d1,(a1)
	lsr.w	#8,d0
	rts
lowbyte:
	lsr.w	#8,d0
	dbra	d6,exist_word
	move.l	d0,d1
	bsr	_readData
	move.l	d1,d0
	rts
exist_word:
	addq.l	#2,(a0)
	moveq.l	#16,d7
	rts

	.even
_readData:
	move.l	-4(a0),-(sp)
	move.l	-8(a0),-(sp)
	move.w	-10(a0),-(sp)
	DOS	__READ
	lea.l	10(sp),sp
	subq.w	#2,d0
	lsr.w	d0
	move.w	d0,d6
	bne	not_empty
	moveq.l	#1,d0
	move.w	d0,42(a0)
not_empty:
	move.l	-8(a0),(a0)
	moveq.l	#15,d7
	
	rts

	.even

	.globl _drawPIC
_drawPIC:
	movem.l	d3/d4/d5/d6/d7/a3/a4/a5/a6,-(sp)
	move.l	40(sp),a0
	move.l	38(a0),50(a0)	*frame		38(a0)
	move.l	a0,-(sp)
	bsr	_iclr
	addq.w	#4,sp
	lea.l	12(a0),a0
	moveq.l	#0,d5
	move.w	d5,42(a0)	*_readerror
	move.l	d5,d7
	move.w	48(a0),d6
	move.w	52(a0),d7
	movea.l	8(a0),a4	*width
	move.w	18(a0),a3	*currenty
	move.l	20(a0),a5	*runlength
	move.l	a4,d1		*width
	movea.l	4(a0),a6

?277:
	lea.l	24(a0),a1	*color
	bra	?280
?297:
	move.l	a4,d0	*width
	sub.l	d5,d0
	sub.l	d0,a5	*runlength
	moveq.l	#0,d5
?283:
	movea.l	38(a0),a2	*frame
	move.w	10(a0),d1	*width
	move.w	(a1),d2
	bra	?288
?294:
	move.w	(a2),d0	*frame
	ror.b	#1,d0
	bpl	?293
	add.b	d0,d0
	move.w	d0,d2
?293:
	move.w	d2,(a2)+	*color->frame
?288:
	dbra	d1,?294
	move.w	d2,(a1)	*color
	move.l	a6,d0
	add.l	d0,38(a0)

	addq.w	#1,a3
	move.w	a3,d0		*currenty
	cmp.w	14(a0),d0
	bne	?296
	move.l	#201,d0		*PICSLICE_TERMINATE
	bra	?276
?296:
?280:
	move.l	d5,d0
	add.l	a5,d0		*runlength
	cmp.l	a4,d0		*width
	bge	?297
	add.l	a5,d5		*runlength

_readColor:
	_readBit1
	bne	?246
	moveq.l	#15,d3
	_readBit7
	lea	1334(a0),a1	*current
	move.w	(a1),d1
	lea.l	-12(a0,d1.w),a2
	move.b	322(a2),d3
	move.w	d3,(a1)
	add.w	d0,d0
	move.w	d0,54(a0,d3.w)
	move.w	d0,d3
	bra	?251
?246:
	moveq.l	#7,d3
	_readBit7
	move.l	d0,d2
	add.w	d2,d2
	move.w	1334(a0),d1
	cmp.w	d1,d2
	beq	?250
	lea	310(a0),a1	*prev
	lea.l	(a1,d2.w),a2
	move.b	(a2)+,d0	*prev[idx]
	move.b	(a2),d3		*next[idx]
	move.b	d1,(a2)		*cc->next[idx]
	move.b	d0,(a1,d3.w)	*prev[idx]->prev[next[idx]]
	move.b	d3,1(a1,d0.w)	*next[idx]->next[prev[idx]]
	move.b	(a1,d1.w),d0	*prev[cc]
	move.b	d0,-(a2)	*prev[cc]->prev[idx]
	move.b	d2,1(a1,d0.w)	*idx->next[prev[cc]]
	move.b	d2,(a1,d1.w)	*idx->prev[cc]

	move.w	d2,1334(a0)	*idx->current
?250:
	move.w	54(a0,d2.w),d3	*color[idx]
?251:
	or.w	#1,d3
	tst.w	42(a0)
	bne	?307
	move.l	d5,d0
	add.w	d0,d0
	movea.l	38(a0),a2	*frame
	move.w	d3,(a2,d0.w)
	_readBit1
	tst.w	42(a0)
	bne	?307
	cmpi.w	#1,d0
	bne	?300
_expandChain:
	move.l	d5,-(sp)
	move.w	14(a0),d4	*height
	sub.w	a3,d4		*currenty
	subq.w	#1,d4
	movea.l	38(a0),a2	*frame
?80:
	moveq.l	#2-1,d2
	_readBit2
	dbra	d0,?88
?84:
	_readBit1
	beq	?147
	_readBit1
	bne	?86
	subq.w	#2,d5
	bra	?83
?86:
	addq.w	#2,d5
	bra	?83
?88:
	dbra	d0,?b2
	subq.w	#1,d5
	bra	?83
?90:
	addq.w	#1,d5
	bra	?83
?b2:
	dbra	d0,?90
?83:
	adda.l	a6,a2		*frame

	tst.w	d5
	blt	?98
	cmp.w	10(a0),d5	*width
	bge	?98
	dbra	d4,?93		*height
?98:
	moveq.l	#2-1,d2
	_readBit2
	bne	?98
	_readBit1
	beq	?147
	_readBit1
	bra	?98
?93:
	move.w	d5,d0
	add.w	d0,d0
	move.w	d3,(a2,d0.w)
	bra	?80
?147:
	moveq.l	#100,d0
	add.w	d0,d0		*PICSLICE_NORMAL
?79:
	move.l	(sp)+,d5
	cmp.w	#200,d0		*PICSLICE_NORMAL
	bne	?276
?300:
	moveq.l	#1,d3
	bra	?303
?305:
	addq.w	#1,d3
?303:
	_readBit1
	bne	?305
	movea.l	d3,a2
	_readBit
	move.l	a2,d3
	move.l	d0,a2
	moveq.l	#1,d0
	asl.l	d3,d0
	lea	-1(a2,d0.l),a5	*runlength
	tst.w	42(a0)
	beq	?277
?307:
	move.l	#203,d0		*PICSLICE_EREAD
?276:
	move.l	d0,d7
	cmp.l	#200,d7
	beq	normalret

	move.l	40(sp),-(sp)
	jbsr	_EndOfDraw
	addq.w	#4,sp
normalret:
	move.l	d7,d0
	movem.l	(sp)+,d3/d4/d5/d6/d7/a3/a4/a5/a6
	rts
	.even

_iclr:				*gram i bit clr
	move.l	4(sp),a1	*psi
	movem.l	d3-d7/a3,-(sp)
	move.l	20(a1),d0	*width
	move.l	24(a1),d1	*height
	movea.l	38(a1),a1	*buf
	mulu	d1,d0
	add.l	d0,d0		*bufsize
	lea.l	(a1,d0.l),a1
	move.l	d0,d1
	lsr.l	#8,d1
	and.w	#$ff,d0

	moveq.l	#0,d2
	move.l	d2,d3
	move.l	d2,d4
	move.l	d2,d5
	move.l	d2,d6
	move.l	d2,d7
	movea.l	d2,a2
	movea.l	d2,a3
	bra	clrlpent
clrxlp:
	movem.l	d2-d7/a2-a3,-(a1)
	movem.l	d2-d7/a2-a3,-(a1)
	movem.l	d2-d7/a2-a3,-(a1)
	movem.l	d2-d7/a2-a3,-(a1)
	movem.l	d2-d7/a2-a3,-(a1)
	movem.l	d2-d7/a2-a3,-(a1)
	movem.l	d2-d7/a2-a3,-(a1)
	movem.l	d2-d7/a2-a3,-(a1)
clrlpent:
	subq.l	#1,d1
	bpl	clrxlp

	bra	clrlp2ent
clrlp2:
	move.w	d2,(a1)+
clrlp2ent:
	dbra	d0,clrlp2

	movem.l	(sp)+,d3-d7/a3
	rts

	.even
	.end
